<?php
/*************************************************************************************/
/*                                                                                   */
/*      Thelia	                                                            		 */
/*                                                                                   */
/*      Copyright (c) Octolys Development		                                     */
/*		email : thelia@octolys.fr		        	                             	 */
/*      web : http://www.octolys.fr						   							 */
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/
?>
<?php

	include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Variable.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Message.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Messagedesc.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Commande.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Client.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../classes/Mail.class.php");
	include_once(realpath(dirname(__FILE__)) . "/../../../fonctions/divers.php");


	class Retouronline extends PluginsClassiques{

        var $id;
        var $commande;
        var $type;
        var $client;
        var $article1;
        var $article2;
        var $remarque;
        var $date;
        var $date_depot;
        var $bretour;
        var $valide;
        var $fichier;
        var $envoye;

        var $table="retouronline";
        var $bddvars = array("id", "commande", "type", "client", "article1", "article2", "remarque", "date", "date_depot", "bretour", "valide", "fichier", "envoye");



		function Retouronline(){
			$this->PluginsClassiques();
		}
		
		function init(){
              $code = gencode(30);
                $variable = new Variable();

                if(! $variable->charger("repbretour")){
	                @mkdir("../client/$code",0755);
   		            $variable->nom = "repbretour";
       		        $variable->valeur = $code;
          		    $variable->protege = 1;
               		$variable->add();
                }

                $cnx = new Cnx();
                $query_bretour = "CREATE TABLE `retouronline` (
									`id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
									`commande` INT NOT NULL ,
									`type` SMALLINT NOT NULL ,
									`client` INT NOT NULL ,
									`article1` TEXT NOT NULL ,
									`article2` TEXT NOT NULL ,
									`remarque` TEXT NOT NULL ,									
									`date` DATETIME NOT NULL ,
									`date_depot` DATETIME NOT NULL ,
									`bretour` TEXT NOT NULL ,
									`valide` SMALLINT NOT NULL ,
									`fichier` TEXT NOT NULL ,
									`envoye` SMALLINT NOT NULL
									) ";
                $resul_bretour = mysql_query($query_bretour, $cnx->link);

                $message = new Message();
                if($message->charger("mailbretour")) return;
                $message->nom = "mailbretour";
                $lastid = $message->add();
                $messagedesc = new Messagedesc();
                $messagedesc->message = $lastid;
                $messagedesc->lang = 1;
                $messagedesc->titre = "Tlchargement";
                $messagedesc->chapo = "";
                $messagedesc->description = "<a href=\"__BRETOUR_LIEN__\">__BRETOUR_BRETOUR__</a>";
                $messagedesc->add();

																		
		}

        function charger($id){
                return $this->getVars("select * from $this->table where id=\"$id\"");
        }
        
        function charger_bretour($bretour){
                return $this->getVars("select * from $this->table where bretour=\"$bretour\"");
        }      



		function action(){
		   if($_REQUEST['action'] == "bretouronline" && $_SESSION['navig']->client->id){
   
//                $smtp->texte = "\n\nNom: $nom \nPr?nom: $prenom \nAdresse: $adresse1 \nAdresse suite: $adresse2 \nAdresse compl?ment: $adresse3 \nCode postal: $cpostal \nVille: $ville \nAdresse email: $email \nT?l?phone: $tel \n\n\nN? de commande: $commande \nDate de la commande: $date \nR?f?rence du produit en retour: $article1 \nR?ference du deuxieme article en retour: $article2 \n\n\nRemarques: $demande \n";
  	
  	 			$commande = new Commande();
   				$commande->charger_ref($_REQUEST['commande']);

				$client = new Client();
				$client->charger_id($commande->client);
				
								
    	    	$this->commande = $commande->id;    
   		     	$this->client = $_SESSION['navig']->client->id;    
		      	$this->date = date("Y-m-d H:i:s");
  		      	$this->bretour = "";
        		$this->fichier = "";
       			$this->valide = 0;
       			$this->envoye = 0;
       			$this->type = $_REQUEST['type'];
       			$this->article1 = $_REQUEST['article1'];
				$this->article2 = $_REQUEST['article2'];
				$this->remarque = $_REQUEST['demande'];
				
	
				$this->add();
	
			}	
		
		}
		
		
		function valide(){
			
			$commande = new Commande();
			$commande->charger($this->commande);			
			
			$client = new Client();
			$client->charger_id($this->client);
			
			$this->date_depot = date("Y-m-d H:i:s");
			
			$date = substr($this->date_depot, 0, 10);
			$heure = substr($this->date_depot, 11);

			include_once(realpath(dirname(__FILE__)) . "/config.php");

	$xml = "<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:wsp=\"http://wsproxy.retour.coliposte.telintrans.fr\">
   <soapenv:Header/>
   <soapenv:Body>
      <wsp:getLetter>
         <wsp:letter>
            <wsp:password>" . $motdepasse ."</wsp:password>
            <wsp:contractNumber>" . $identifiant . "</wsp:contractNumber>
            <wsp:service>
               <wsp:dateDeposite>" . $date . "T" . $heure . "Z" . "</wsp:dateDeposite>
               <wsp:returnType>CreatePDFFile</wsp:returnType>
               <wsp:serviceType>8R</wsp:serviceType>
               <wsp:commandNumber>" . $commande->ref ."</wsp:commandNumber>
               <wsp:motiveBack>" . "" . "</wsp:motiveBack>
            </wsp:service>
            <wsp:parcel>
               <wsp:horsGabarit>false</wsp:horsGabarit>
            </wsp:parcel>
            <wsp:dest>
               <!--Optional:-->
               <wsp:ref>" . "" . "</wsp:ref>
               <wsp:entity>
          <!--Optional:-->
          <wsp:Surname>" . $prenom . "</wsp:Surname>
          <!--Optional:-->
          <wsp:Name>$nom</wsp:Name>
          <wsp:companyName>" . $companyName . "</wsp:companyName>
          <!--Optional:-->
          <wsp:serviceInfo>" . $serviceinfo . "</wsp:serviceInfo>
               </wsp:entity>
               <wsp:address>
          <wsp:line0>" . $adresse . "</wsp:line0>
          <!--Optional:-->
          <wsp:line1>" . "" . "</wsp:line1>
          <!--Optional:-->
          <wsp:line2>" . "" . "</wsp:line2>
          <!--Optional:-->
          <wsp:line3>" . "" . "</wsp:line3>
          <!--Optional:-->
          <wsp:phone>" . "" . "</wsp:phone>
          <!--Optional:-->
          <wsp:country>" . "" . "</wsp:country>
          <wsp:countryCode>" . $pays . "</wsp:countryCode>
          <wsp:city>" . $ville . "</wsp:city>
          <!--Optional:-->
          <wsp:email>" . $email . "</wsp:email>
          <wsp:postalCode>" . $cpostal . "</wsp:postalCode>
               </wsp:address>
               <wsp:codeBarForreference>true</wsp:codeBarForreference>
            </wsp:dest>
            <wsp:exp>
               <wsp:entity>
          <!--Optional:-->
          <wsp:civility>" ."?" . "</wsp:civility>
          <!--Optional:-->
          <wsp:Surname>" . $client->prenom . "</wsp:Surname>
          <!--Optional:-->
          <wsp:Name>" . $client->nom . "</wsp:Name>
          <!--Optional:-->
          <wsp:companyName>" . $client->entreprise . "</wsp:companyName>
               </wsp:entity>
               <wsp:address>
          <wsp:line0>" . $client->adresse1 . "</wsp:line0>
          <!--Optional:-->
          <wsp:line1>" . $client->adresse2 ."</wsp:line1>
          <!--Optional:-->
          <wsp:line2>" . $client->adresse3 . "</wsp:line2>
          <!--Optional:-->
          <wsp:line3>" . "" . "</wsp:line3>
          <!--Optional:-->
          <wsp:phone>" . "" . "</wsp:phone>
          <!--Optional:-->
          <wsp:country>" . "" . "</wsp:country>
          <wsp:countryCode>" . "FR" . "</wsp:countryCode>
          <wsp:city>" . $client->ville . "</wsp:city>
          <!--Optional:-->
          <wsp:email>" . $client->email ."</wsp:email>
          <wsp:postalCode>" . $client->cpostal . "</wsp:postalCode>
               </wsp:address>
            </wsp:exp>
         </wsp:letter>
      </wsp:getLetter>
   </soapenv:Body>
</soapenv:Envelope>";
			$client = new SoapClient("http://ws.coliposte.fr/soap.shippingclp-return-ws-proxy/services/WSColiPosteLetterReturnService?wsdl");
			$res = $client->__doRequest(utf8_encode($xml), "http://ws.coliposte.fr/soap.shippingclp-return-ws-proxy/services/WSColiPosteLetterReturnService?wsdl", "", "1.1");

			preg_match("/<PdfUrl>([^<]*)<\/PdfUrl>/", $res, $cut);

			$url = str_replace("&amp;", "&", $cut[1]);	

			preg_match("/<parcelNumber>([^<]*)<\/parcelNumber>/", $res, $cut);

            $repbretour = new Variable();
            $repbretour->charger("repbretour");

            $code = gencode(30);

			$file = file_get_contents($url);

			file_put_contents("../client/" . $repbretour->valeur . "/" . $code . ".pdf", $file);

        	$this->bretour = $cut[1];
        	$this->fichier = $code;
			$this->valide = 1;
   
			$this->mail();
			$this->envoye = 1;
			$this->maj();
			
		}
		

       function mail(){
			$sujet="";
			$corps="";

			$client = new Client();
			$client->charger_id($this->client);

	  		$emailfrom = new Variable();
	  		$emailfrom->charger("emailcontact");

			$msg = new Message();

			$msg->charger("mailbretour");
			$msgdesc = new Messagedesc();
			$msgdesc->charger($msg->id);
			$sujet = $this->substitmail($msgdesc->titre);

			$corps = $msgdesc->description;
			$corps = $this->substitmail($corps);
			$corpstext = $msgdesc->descriptiontext;
			$corpstext = $this->substitmail($corpstext);
			
			$mailclient = new Mail();
			$mailclient->IsMail();
			$mailclient->FromName = $nomsite->valeur;
			$mailclient->From = $emailfrom->valeur;
			$mailclient->Subject = $sujet;
			$mailclient->MsgHTML($corps);
			$mailclient->AltBody = $corpstext;
			$mailclient->AddAddress($client->email, $client->prenom . " " . $client->nom);

			$mailclient->send();

	   }

	  function substitmail($texte){
	  	$urlsite = new Variable();
	  	$urlsite->charger("urlsite");
	  	
	  	$url = $this->shortUrl($urlsite->valeur . "/client/plugins/retouronline/visu.php?id=" . $this->bretour . "&token=" . $this->fichier);
	  	
	  	$texte = str_replace("__BRETOUR_LIEN__", $url, $texte);
	  	$texte = str_replace("__BRETOUR_BRETOUR__", $this->bretour, $texte);
	  	
	  	return $texte;
	  }
	


      function shortUrl($url){
          $tab = array();
          $tab["link[url]"] = $url;
                
          $ch = curl_init();

          curl_setopt($ch, CURLOPT_URL, "http://tweetburner.com/links");
          curl_setopt($ch, CURLOPT_POST, 1);
          curl_setopt($ch, CURLOPT_POSTFIELDS, $tab);
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

          $output = curl_exec($ch);
                
          curl_close($ch);
		  $this->urln = $url;
		  $this->urlr = $output;
		  $this->add();
			
          return $output;
      }	
	
	}

?>
